import urlparse
import subprocess


def showUrl(url, logger=None):
    """Show the given URL in the user's preferred browser.

    Currently just shells out to gnome-open, which uses the browser
    picked in the Gnome "preferred applications" control panel.
    """
    if logger:
        logger.info('opening URL %s', url)
    p = subprocess.Popen(['gnome-open', url],
                         stdin=subprocess.PIPE,
                         stdout=subprocess.PIPE)
    p.communicate()
    return p.returncode

def launchpadDistroPrefix():
    distro = subprocess.Popen(['lsb_release', '--id', '--short'],
                              stdin=subprocess.PIPE,
                              stdout=subprocess.PIPE).communicate()[0].strip()
    release = subprocess.Popen(['lsb_release', '--codename', '--short'],
                               stdin=subprocess.PIPE,
                               stdout=subprocess.PIPE).communicate()[0].strip()
    return 'https://launchpad.ubuntu.com/distros/%s/%s/' % (distro.lower(),
                                                            release)

def getSourcePackageUrl(pkginfo):
    prefix = launchpadDistroPrefix()
    return urlparse.urljoin(prefix, '+sources/%s/' % pkginfo.sourcepackage)

def getInfoUrl(pkginfo):
    return urlparse.urljoin(getSourcePackageUrl(pkginfo), '+gethelp')

def getTranslateUrl(pkginfo):
    return urlparse.urljoin(getSourcePackageUrl(pkginfo), '+translate')

# def getBugURL(pkginfo):
#     return urlparse.urljoin(getSourcePackageUrl(pkginfo), '+bugs')
